(function () {
    
    // Datatables setup.
    var dataTable = $('#offenders').DataTable({
        'dom': 'Bfrtip',
        "bInfo": false,
        'buttons': [
            'csv'
        ],
        'ajax': {
            'url': '/metrics',
            'contentType': 'application/json',
            'type': 'GET',
            'dataSrc': function (data) {
                var attackers = data.attackers
                return Object.keys(attackers).map(function (item) {
                    return {
                        IP: item,
                        Count: attackers[item].count,
                        Stamp: attackers[item].stamp
                    }
                })
            }
        },
        'order': [1, 'desc', 'desc'],
        'ordering': true,
        'searching': true,
        'columns': [
            { 'data': 'IP' },
            { 'data': 'Count' },
            { 'data': 'Stamp' }
        ]
    })

    $('#offenders tbody').on( 'click', 'tr', function () {
        var ip = $(this).children(":first").text()
        $("#myModal-header").html("WHOIS Information")
        //$("#myModal-body").html('<img style="display: block margin:auto" src="img/interwind-loader.svg"></img>')
        $("#myModal").modal()
        $.get(`/whois/${ip}`, (data) => {
            $("#myModal-body").html(data)
            $("#myModal").modal()
        })
    })

    // Update data table.
    setInterval(function () {
        dataTable.ajax.reload(null, false) // user paging is not reset on reload
    }, 1000)

})()